function result = InnerProd_Q(q1,q2,varargin)

N = size(q1,2);

if isempty(varargin)
    t = 0;
else 
    t = varargin{1};
    if length(t) ~= N
        error('The length of t has to be the same as the number of columns in q!');
    end
end

if isscalar(t) % Uniformly discretized with const spacing h.
    h = 1/(N-1);
    result = h * trapz(sum(q1.*q2,1));
else % Nonuniformly discretized at grid points t.
    result = trapz( t, sum(q1.*q2,1) );
end
